#if !defined(IDENT_OFF)
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 7)
static const char ident[] =
  "@(#)$Id: readline.cc,v 1.1 2005/10/24 07:01:49 weesan Exp $";
#endif
#endif

#include <stdlib.h>
#include <string.h>
#include "readline.h"

Readline::Readline(const char *_pzcPrompt, const char *_pzcHistoryFile) :
    pzcBuffer(NULL) {
    // Process prompt
    prompt(_pzcPrompt);
    
    // Process history file
    if (strncmp(_pzcHistoryFile, "~/", 2) == 0) {	
	// Replace ~/ with values from $HOME
	snprintf(pzcHistoryFile, sizeof(pzcHistoryFile), "%s/%s",
		 getenv("HOME"), _pzcHistoryFile + 2);
    } else {
	// Or, simply copy from the original
	snprintf(pzcHistoryFile, sizeof(pzcHistoryFile), "%s",
		 _pzcHistoryFile);
    }
    // Read the previous history contents
    read_history(pzcHistoryFile);
}

Readline::~Readline(void) {
    // Free up memory allocated by readline library if any
    if (pzcBuffer) {
	free(pzcBuffer);
    }
    // Write the history contents into the history file
    write_history(historyFile());
}

