// $Id: readline.h,v 1.1 2005/10/24 07:01:49 weesan Exp $

#ifndef READLINE_H
#define READLINE_H

#include <stdio.h>                 // Have to include this before readline.h
#include <stdlib.h>
//extern "C" {
#include <readline/readline.h>     // For readline()
#include <readline/history.h>      // For add_history()
//}

class Readline {
private:
    char pzcPrompt[256];
    char pzcHistoryFile[256];
    char *pzcBuffer;               // Need to be freed

public:
    Readline(const char *_pzcPrompt, const char *_pzcHistoryFile);
    ~Readline(void);
    const char *prompt(void) const {
	return (pzcPrompt);
    }
    void prompt(const char *_pzcPrompt) {
	snprintf(pzcPrompt, sizeof(pzcPrompt), "%s", _pzcPrompt);
    }
    const char *historyFile(void) const {
	return (pzcHistoryFile);
    }
    const char *buffer(void) {
	// Free previous memory allocated by readline() from readline library
	if (pzcBuffer) {
	    free(pzcBuffer);
	}
	// Get a new chunk of memory
	pzcBuffer = readline((char *)prompt());
	// Add it into history file if it's not null
	if (pzcBuffer && *pzcBuffer) {
	    add_history(pzcBuffer);
	}
	// Return the returned value from readline()
	return (pzcBuffer);
    }
};

extern Readline cReadline;

#endif // READLINE_H
